import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * A bomb shooting turret.
 * 
 * @author Ninto
 * @version 0.1
 */
public class BombTurret  extends Turret
{
    /**
     * Create a bombTurret.
     */
    public BombTurret() {
        range = 75;
        rate = 64;
        staticImg = new GreenfootImage("bombTurret.png");
        price = 20;
    }
    
    /**
     * Shoot a <i><b>BOMB</i></b>.
     */
    protected void shootBullet() {
        int x = (int)Math.round(Math.cos(Math.toRadians(getRotation()))*staticImg.getWidth()/2)+getX();
        int y = (int)Math.round(Math.sin(Math.toRadians(getRotation()))*staticImg.getHeight()/2)+getY();
        getWorld().addObject(new Bomb(getRotation(), attack), x, y);
    }
}