import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * A bullet.
 * 
 * @author Ninto
 * @version 0.1
 */
public class Bullet  extends Actor
{
    /**The direction in degrees*/
    private int dir;
    /**How much damage this can made*/
    protected int damage;
    private double x, y;
    
    /**
     * Create a bullet.
     */
    public Bullet(int dir, int damage) {
        this.dir = dir;
        this.damage = damage;
    }
    
    protected void addedToWorld(World world) {
        x = getX();
        y = getY();
    }
    
    /**
     * Super very much acty.
     */
    public void act() {
        for(int i=0; i<12; i++) {
            double angle = Math.toRadians(dir);
            x += Math.cos(angle);
            y += Math.sin(angle);
            setLocation((int)Math.round(x), (int)Math.round(y));
            if(getOneIntersectingObject(Enemy.class) != null) {
                hit();
                getWorld().removeObject(this);
                return;
            }
        }
        if(getX() == 0 || getX() == getWorld().getWidth()-1
        || getY() == 0 || getY() == getWorld().getHeight()-1)
        getWorld().removeObject(this);
    }
    
    /**
     * Hitted!
     */
    protected void hit() {
        Enemy target = (Enemy)getOneIntersectingObject(Enemy.class);
        target.health -= damage;
    }
}