import greenfoot.*;

public class FireStorm extends Smoke
{
    private int damage;
    
    public FireStorm(boolean children, int damage) {
        super(children);
        this.damage = damage;
    }
    
    protected void addedToWorld(World world) {
        java.util.List<Enemy> enemies = getIntersectingObjects(Enemy.class);
        if(!enemies.isEmpty()) {
            for(int i=0; i<enemies.size(); i++) {
                Enemy target = (Enemy)enemies.get(i);
                if(myWorld.randomChance(damage*10)) target.setMode(Enemy.BURN_MODE);
            }
        }
    }
    
    /**
     * Spawny...
     */
    protected void spawn() {
        for (int i = 0; i < children; i++) {
            int x = getX() + Greenfoot.getRandomNumber(SPREAD) - (SPREAD/2);
            int y = getY() + Greenfoot.getRandomNumber(SPREAD) - (SPREAD/2);
            getWorld().addObject(new FireStorm(false, damage), x, y);
        }
    }
}