import greenfoot.*;

public class IceStorm extends Smoke
{
    private int damage;
    
    public IceStorm(boolean children, int damage) {
        super(children);
        this.damage = damage;
    }
    
    protected void addedToWorld(World world) {
        java.util.List<Enemy> enemies = getIntersectingObjects(Enemy.class);
        if(!enemies.isEmpty()) {
            for(int i=0; i<enemies.size(); i++) {
                Enemy target = (Enemy)enemies.get(i);
                if(myWorld.randomChance(damage*15)) target.setMode(Enemy.FROZ_MODE);
            }
        }
    }
    
    /**
     * Spawny...
     */
    protected void spawn() {
        for (int i = 0; i < children; i++) {
            int x = getX() + Greenfoot.getRandomNumber(SPREAD) - (SPREAD/2);
            int y = getY() + Greenfoot.getRandomNumber(SPREAD) - (SPREAD/2);
            getWorld().addObject(new IceStorm(false, damage), x, y);
        }
    }
}