import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * A label.
 * 
 * @author Ninto
 * @version 0.1
 */
public class Label  extends Actor
{
    /**My prefix*/
    private final String prefix;
    /**My value*/
    private int value;
    /**My target*/
    private int target;
    
    /**
     * Ultra acty.
     */
    public void act()
    {
        if(target != value) {
            if(target < value) value--;
            if(target > value) value++;
            updateImage();
        }
    }
    
    /**
     * Create a label.
     */
    public Label(String prefix, int value, java.awt.Color color) {
        this.prefix = prefix;
        target = value;
        this.value = value;
        setImage(new GreenfootImage((prefix.length() + 3)*18, 32));
        getImage().setColor(color);
        updateImage();
    }
    
    /**Return the value*/
    public int getValue() {
        return target;
    }
    
    /**Return the showed value*/
    public int getShowedValue() {
        return value;
    }
    
    /**Set the showed value*/
    public void setShowedValue(int value) {
        this.value = value;
        setValue(value);
    }
    
    /**Set the value*/
    public void setValue(int value) {
        if(value > 999) value = 999;
        if(value < 0) value = 0;
        target = value;
        updateImage();
    }
    
    /**Return the prefix*/
    public String getPrefix() {
        return prefix;
    }
    
    /**
     * Update the image.
     */
    private void updateImage() {
        GreenfootImage img = getImage();
        img.setFont(new java.awt.Font(null, java.awt.Font.BOLD, 24));
        img.clear();
        img.drawString(prefix+": "+value, 1, 24);
    }
}