import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.*;

/**
 * The menu.
 * 
 * @author Ninto
 * @version 0.1
 */
public class Menu  extends Actor
{
    /**The buttons location*/
    private int[] pointA = {12, 58, 56, 102}, pointB = {72, 58, 116, 102}, pointC = {12, 128, 56, 172}, pointD = {72, 128, 116, 172},
    skipPoint = {27, 196, 99, 220}, nextButton = {100, 196, 124, 220}, prevButton = {3, 196, 27, 220};
    /**The absolute zero*/
    private int zeroX, zeroY;
    private int page;
    private static final int max = 1;
    
    private static GreenfootImage[] img = new GreenfootImage[max+1];
    
    /**
     * This is now oficial added to the world.
     */
    protected void addedToWorld(World world) {
        zeroX = getX()-getImage().getWidth()/2;
        zeroY = getY()-getImage().getHeight()/2;
    }
    
    /**
     * Create a menu.
     */
    public Menu() {
        for(int i=0; i<=max; i++) {
            img[i] = new GreenfootImage(128, 480);
            
            img[i].setColor(Color.DARK_GRAY);
            img[i].fill();
            img[i].setColor(Color.BLACK);
            img[i].drawRect(0, 0, img[i].getWidth()-1, img[i].getHeight()-1);
            img[i].setFont(new Font(null, java.awt.Font.BOLD, 24));
            img[i].setColor(Color.WHITE);
            img[i].drawString("Menu", 28, 32);
            img[i].drawRect(12, 58, 44, 44);
            img[i].drawRect(72, 58, 44, 44);
            img[i].drawRect(12, 128, 44, 44);
            img[i].drawRect(72, 128, 44, 44);
            img[i].drawRect(12, 232, 104, 232);
        
            GreenfootImage button = new GreenfootImage("button.png");
            img[i].drawImage(button, 27, 196);
            GreenfootImage arrow = new GreenfootImage("arrow.png");
            img[i].drawImage(arrow, 100, 196);
            arrow.mirrorHorizontally();
            img[i].drawImage(arrow, 3, 196);
            img[i].setColor(Color.BLACK);
            img[i].setFont(new Font("stat", Font.BOLD, 14));
            img[i].drawString("Skip", 47, 212);
        }
        img[0].setColor(Color.WHITE);
        img[0].drawImage(new GreenfootImage("bulletTurret.png"), 18, 64);
        img[0].drawImage(new GreenfootImage("bombTurret.png"), 78, 64);
        img[0].drawImage(new GreenfootImage("poisonTurret.png"), 18, 134);
        img[0].drawImage(new GreenfootImage("laserTurret.png"), 78, 134);
        img[0].setFont(new Font("", Font.BOLD, 10));
        img[0].drawString("Cost: 10", 14, 115);
        img[0].drawString("Cost: 20", 74, 115);
        img[0].drawString("Cost: 50", 14, 185);
        img[0].drawString("Cost: 100", 70, 185);
        img[1].setColor(Color.WHITE);
        img[1].drawImage(new GreenfootImage("flameTurret.png"), 18, 64);
        img[1].drawImage(new GreenfootImage("iceTurret.png"), 78, 64);
        img[1].setFont(new Font("", Font.BOLD, 10));
        img[1].drawString("Cost: 30", 14, 115);
        img[1].drawString("Cost: 30", 74, 115);
        
        setImage(img[0]);
    }
    
    /**
     * Return a myWorld.
     */
    public myWorld getWorld() {
        return (myWorld)super.getWorld();
    }
    
    /**
     * Hyper super acty.
     */
    public void act() {
        if(getWorld().getObjectsAt(myWorld.mx, myWorld.my, Turret.class).isEmpty()) {
            if(page == 0) {
                if(clickedAt(pointA) && getWorld().getMoney() >= 10)
                getWorld().addObject(new BulletTurret(), myWorld.mx, myWorld.my);
                
                if(clickedAt(pointB) && getWorld().getMoney() >= 20)
                getWorld().addObject(new BombTurret(), myWorld.mx, myWorld.my);
                
                if(clickedAt(pointC) && getWorld().getMoney() >= 50)
                getWorld().addObject(new PoisonTurret(), myWorld.mx, myWorld.my);
                
                if(clickedAt(pointD) && getWorld().getMoney() >= 100)
                getWorld().addObject(new LaserTurret(), myWorld.mx, myWorld.my);
            }
            if(page == 1) {
                if(clickedAt(pointA) && getWorld().getMoney() >= 30)
                getWorld().addObject(new FlameTurret(), myWorld.mx, myWorld.my);
                
                if(clickedAt(pointB) && getWorld().getMoney() >= 30)
                getWorld().addObject(new FrozenTurret(), myWorld.mx, myWorld.my);
            }
        }
        if(clickedAt(nextButton) && page < max) {
            page++;
            setImage(img[page]);
        }
        if(clickedAt(prevButton) && page > 0) {
            page--;
            setImage(img[page]);
        }
        if(clickedAt(skipPoint) && getWorld().Time.getValue() <= 40) getWorld().nextWave();
    }
    
    /**
     * Clicked at a point described by a int array of 4.
     */
    protected boolean clickedAt(int[] location) {
        return Greenfoot.mousePressed(this) && myWorld.mx > zeroX+location[0] && myWorld.mx < zeroX+location[2]
        && myWorld.my > zeroY+location[1] && myWorld.my < zeroY+location[3];
    }
}