import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.*;

/**
 * The options-menu.
 * 
 * @author Ninto
 * @version 0.1
 */
public class Options  extends Menu
{
    /**The 2 buttons*/
    private int[] pointA = {15, 156, 87, 180}, pointB = {15, 196, 87, 220};
    
    /**The image*/
    private GreenfootImage img;
    /**The related turret*/
    Turret turret;
    /**Image is null*/
    private boolean nullImage = true;
    /**The <i>stats</i>*/
    private int[] stats = new int[5];
    private static final Font smallText = new Font("smallText", Font.BOLD, 12);
    private static final Font NAME = new Font("name", Font.BOLD, 18);
    private static final Font STAT = new Font("stat", Font.BOLD, 14);
    
    /**
     * Create a option-menu.
     */
    public Options() {
        reset();
    }
    
    /**
     * Reset the image
     */
    public void reset() {
        img = new GreenfootImage(103, 231);
        setImage(img);
        nullImage = true;
    }
    
    /**Paint stuff*/
    public void paint(String name, int atk, int uAtk, int rate, int uRate,
    int range, int uRange, int cost, int level, Turret turret) {
        this.turret = turret;
        reset();
        img.setColor(Color.WHITE);
        img.drawLine(6, 132, 97, 132);
        img.setFont(NAME);
        img.drawString(name, 6, 22);
        img.setFont(smallText);
        img.drawString("Atk:", 6, 48);
        img.drawString("Rate:", 6, 72);
        img.drawString("Ran:", 6, 96);
        img.drawString("Lvl:", 6, 120);
        
        img.setFont(STAT);
        img.setColor(Color.GREEN);
        img.drawString(""+atk, 40, 48);
        img.drawString(""+rate, 40, 72);
        img.drawString(""+range, 40, 96);
        img.drawString(""+level, 40, 120);
        
        img.setColor(Color.RED);
        img.drawString(""+uAtk, 70, 48);
        img.drawString(""+uRate, 70, 72);
        img.drawString(""+uRange, 70, 96);
        img.drawString(""+(level+1), 70, 120);
        
        img.setColor(Color.BLACK);
        GreenfootImage button = new GreenfootImage("button.png");
        img.drawImage(button, 15, 156);
        img.drawImage(button, 15, 196);
        img.drawString("Upgrade", 22, 172);
        img.drawString("Sell", 39, 212);
        img.setFont(smallText);
        img.setColor(Color.WHITE);
        img.drawString("Cost: "+cost, 22, 154);
        img.drawString("Gain: "+cost, 22, 194);
        
        int[] STATS = {uAtk, uRate, uRange, cost, level};
        stats = STATS;
        nullImage = false;
    }
    
    /**
     * Not so acty...
     */
    public void act() {}
    
    /**
     * <b>Act</b>ually is this more acty than act.
     */
    public void check() {
        if(nullImage) return;
        if(clickedAt(pointB)) {
            getWorld().setMoney(getWorld().getMoney()+stats[3]*stats[4]);
            reset();
            getWorld().removeObject(turret);
        }
        if(clickedAt(pointA) && getWorld().getMoney() >= stats[3]) {
            turret.setStats(stats[0], stats[1], stats[2]);
            getWorld().setMoney(getWorld().getMoney()-stats[3]);
        }
    }
}