import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * A puff of smoke. Once placed into the world, it quickly evaporates and
 * then disappears.
 * 
 * @author Ninto <i>(original: Michael Kolling)
 * @version 1.1
 */
public class Smoke extends Actor
{
    /**How much i will spread*/
    protected int SPREAD = 20;
    /**The delay*/
    private int delay;
    
    /**How much i will fade out*/
    private int fade;
    /**How many other smokes i will create*/
    protected int children;
    
    /**
     * Create a smoke.
     */
    public Smoke(boolean children) {
        fade = Greenfoot.getRandomNumber(10)+5;
        delay = Greenfoot.getRandomNumber(4)+1;
        if(children) this.children = 3;
        else this.children = 0;
    }

    /**
     * In every step, get smaller until we disappear.
     */
    public void act() {
        delay--;
        if(delay == 0) spawn();
        if(Greenfoot.getRandomNumber(3) > 0) shrink();
    }    
    
    /**
     * Spawny...
     */
    protected void spawn() {
        for (int i = 0; i < children; i++) {
            int x = getX() + Greenfoot.getRandomNumber(SPREAD) - (SPREAD/2);
            int y = getY() + Greenfoot.getRandomNumber(SPREAD) - (SPREAD/2);
            getWorld().addObject(new Smoke(false), x, y);
        }
    }
    
    /**
     * Shrinky...
     */
    private void shrink() {
        GreenfootImage img = getImage();
        if(img.getTransparency() < 30) getWorld().removeObject(this);
        else img.setTransparency(img.getTransparency() - fade);
    }
}
