import greenfoot.*;
import java.awt.Color;

public class Stage extends Actor
{
    private String code, wave;
    private static final Color PATH = new Color(255, 255, 204), WATER = new Color(51, 153, 255),
    BASE = new Color(153, 0, 0), CASTLE = new Color(102, 204, 51), GROUND = new Color(205, 154, 101);
    
    public Stage(String code, String wave) {
        if(code.length() + wave.length() != 320) {
            System.err.println("Code could not be used because the code dont has the right length.");
            return;
        }
        paintImg(code);
        this.code = code;
        this.wave = wave;
    }
    
    private void paintImg(String code) {
        GreenfootImage img = new GreenfootImage(160 +2, 120 +2);
        for(int i=0; i<300; i++) {
            char color = code.charAt(i);
            if(toColor(color) != null) {
                img.setColor(toColor(color));
                int x = (i % 20)*8;
                int y = (i / 20)*8;
                img.fillRect(x+1, y+1, 8, 8);
            }
        }
        img.setColor(Color.BLACK);
        img.drawRect(0, 0, img.getWidth()-1, img.getHeight()-1);
        setImage(img);
    }
    
    private Color toColor(char color) {
        if(color == 'A' || color == 'B' || color == 'C' || color == 'D' || color == 'E'
        || color == 'I' || color == 'J') return PATH;
        if(color == 'F' || color == 'G' || color == 'H') return WATER;
        if(color == 'K') return BASE;
        if(color == 'L') return CASTLE;
        if(color == '0') return GROUND;
        return null;
    }
    
    public void act() {
        if(Greenfoot.mousePressed(this))
        ((myWorld)getWorld()).buildScene(code + wave);
        if(code == null) getWorld().removeObject(this);
    }
}