/**
 * The class with the stats of the enemies.
 * 
 * @author Ninto
 * @version 0.1
 */
public class Wave  
{
    /**How many enemies left*/
    private int enemiesLeft;
    /**The type of this*/
    private String waveType;
    /**The stats of all enemies*/
    private int strength, health, price;
    /**The valid types*/
    private String[] TYPES = {
        "NORMAL", "FAST", "HARD", "BIG"
    };
    
    /**
     * Create a wave.
     */
    public Wave(String type, int size, int strength, int health, int price) {
        this.strength = strength;
        this.health = health;
        this.price = price;
        enemiesLeft = size;
        String existings = "";
        for(int i=0; i<4; i++) {
            if(i == 3)
            existings += TYPES[i]+".";
            else existings += TYPES[i]+", ";
        }
        if(!type.equals(TYPES[0]) && !type.equals(TYPES[1]) && !type.equals(TYPES[2]) && !type.equals(TYPES[3])) {
            System.err.println("Wave type \""+type+"\" does not exist.");
            System.err.println("The existing wave types is: "+existings);
        }
        else waveType = type;
    }
    
    /**
     * Is there more enemies in here?
     */
    public boolean enemiesLeft() {
        return enemiesLeft > 0;
    }
    
    /**
     * Return a enemy.
     */
    public Enemy next() {
        if(enemiesLeft > 0) {
            enemiesLeft--;
            if(waveType.equals("NORMAL")) return new NormalEnemy(strength, health, price);
            if(waveType.equals("FAST")) return new SpeedEnemy(strength, health, price);
            if(waveType.equals("HARD")) return new ShellBug(strength, health, price);
            if(waveType.equals("BIG")) return new BigEnemy(strength, health, price);
        }
        System.err.println("Not enough enemies left");
        return null;
    }
    
    /**
     * To string.
     */
    public String toString() {
        return waveType+"/"+enemiesLeft+"/"+strength+", "+health+", "+price;
    }
}