import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * The world. Nothing more to say.
 * 
 * @author Ninto
 * @version 0.1
 */
public class myWorld  extends World
{
    private int nextWaveIn, frame;
    
    /**The current position of the mouse*/
    public static int mx, my;
    
    /**The stats of the waves*/
    private int strength, health, waveNum;
    
    /**The base to spawn the enemies*/
    private Base myBase;
    
    /**The code of the waves*/
    private char[] wave = new char[20];
    
    /**Some codes for sample-maps*/
    static final String[] sample = {
        "0000000000000F000000"+
        "00000DAAAAAAAIE00000"+
        "GGGGGJGGGGGGGHJGGGGG"+
        "00000A0000000FA00000"+
        "00000A00DAAAAIAAAE00"+
        "00000A00A0000FA00A00"+
        "00000A00A00DAIAAAB00"+
        "00000A00A00A0FA00000"+
        "00KAAAAAAAAAAIB00000"+
        "00000A00A00A0F000000"+
        "00000A00A00A0F000000"+
        "GGGGGJGGJGGJGHGGGGGG"+
        "00000A00A00A0F000000"+
        "00000CAAB00L0F000000"+
        "0000000000000F000000",
        
        "0000000000F000000000"+
        "000DAAAAAAIAAAAE0000"+
        "000A000000F0000A0000"+
        "000A000000F0000A0000"+
        "000A0DAAAAIAAAAB0000"+
        "000A0A0000F000000000"+
        "000A0A0000F000000000"+
        "000A0CAAAAIAAAAE0000"+
        "000A000000F0000A0000"+
        "000A000000F0000A0000"+
        "000A0DAAAAIAAAAB0000"+
        "000A0A0000F000000000"+
        "000A0A0000F000000000"+
        "00KB0CAAAAIAAAAL0000"+
        "0000000000F000000000",
        
        "AABACADAABACADADDDDB"
    };
    /**Some other stuff*/
    private final Label Health = new Label("Health", 50, java.awt.Color.DARK_GRAY);
    /**Some other stuff*/
    private final Label Money = new Label("Money", 30, java.awt.Color.DARK_GRAY);
    /**Some other stuff*/
    final Label Time = new Label("Time", 0, java.awt.Color.DARK_GRAY);
    /**Some other stuff*/
    private final Options option = new Options();
    
    /**
     * Create a new world.
     */
    public myWorld() {
        super(640, 480, 1);
        Greenfoot.setSpeed(50);
        setPaintOrder(Stage.class, Sign.class, Label.class, Options.class, Menu.class, Smoke.class, Turret.class, Enemy.class, Bullet.class, Path.class);
        addObject(new Stage(sample[0], sample[2]), getWidth()/3, getHeight()/2);
        addObject(new Stage(sample[1], sample[2]), getWidth()/3*2, getHeight()/2);
    }
    
    /**
     * Acty...
     */
    public void act() {
        updateMouse();
        option.check();
        Time.setShowedValue(nextWaveIn);
        if(myBase != null) {
            if(waveNum >= 21) {
                addObject(new Smoke(true), myBase.getX(), myBase.getY());
                removeObject(myBase);
                addObject(new Sign("Winner!", java.awt.Color.GREEN, 64), getWidth()/2, getHeight()/2);
                Greenfoot.stop();
                return;
            }
            if(nextWaveIn <= 0) nextWave();
            else {
                frame++;
                frame %= 64;
                if(frame == 0) nextWaveIn--;
            }
        }
        if(Health.getShowedValue() == 0) {
            addObject(new Sign("Game Over", java.awt.Color.RED, 64), getWidth()/2, getHeight()/2);
            Greenfoot.stop();
        }
    }
    
    /**
     * Update the mx- and my-stats if changed.
     */
    private void updateMouse() {
        if(Greenfoot.getMouseInfo() == null) return;
        mx = Greenfoot.getMouseInfo().getX();
        my = Greenfoot.getMouseInfo().getY();
    }
    
    /**
     * Use a 320-cifred code to build a new scene.
     */
    public void buildScene(String scene) {
        if(scene == null || scene.length() != 320) {
            System.err.println("Code could not be read because it not has the right length.");
            return;
        }
        strength=1;
        health=1;
        nextWaveIn = 0;
        frame = 0;
        waveNum = 0;
        removeObjects(getObjects(Stage.class));
        removeObjects(getObjects(GridActor.class));
        removeObjects(getObjects(Enemy.class));
        addObject(Health, 100, 450);
        addObject(Money, 90, 420);
        addObject(new Menu(), 640-64, 240);
        addObject(option, 576, 348);
        addObject(Time, 100, 390);
        
        for(int i=0; i<300; i++) {
            char obj = scene.charAt(i);
            if(toObject(obj) != null) {
                int x = i % 20;
                int y = i / 20;
                addObject(toObject(obj), x*32, y*32);
            }
        }
        char[] WAVE = new char[20];
        for(int i=300; i<320; i++) {
            WAVE[i-300] = scene.charAt(i);
        }
        wave = WAVE;
        
        setBackground("rock.jpg");
    }
    
    /**
     * Return a object related to a character.
     */
    public GridActor toObject(char obj) {
        if(obj == 'A') return new Path();
        if(obj == 'B') return new Path(0);
        if(obj == 'C') return new Path(1);
        if(obj == 'D') return new Path(2);
        if(obj == 'E') return new Path(3);
        if(obj == 'F') return new Water(0);
        if(obj == 'G') return new Water(1);
        if(obj == 'H') return new Water(2);
        if(obj == 'I') return new Bridge(0);
        if(obj == 'J') return new Bridge(1);
        if(obj == 'K') {
            myBase = new Base();
            return myBase;
        }
        if(obj == 'L') return new Castle();
        return null;
    }
    
    /**Set the health*/
    public void setHealth(int health) {
        Health.setValue(health);
    }
    
    /**Get the health*/
    public int getHealth() {
        return Health.getValue();
    }
    
    /**Set the money*/
    public void setMoney(int money) {
        Money.setValue(money);
    }
    
    /**Get the money*/
    public int getMoney() {
        return Money.getValue();
    }
    
    /**
     * Upload the stats to the selected-menu.
     */
    public void uploadStats(String name, int atk, int uAtk, int rate, int uRate,
    int range, int uRange, int cost, int level, Turret turret) {
        option.paint(name, atk, uAtk, rate, uRate, range, uRange, cost, level, turret);
    }
    
    /**Reset the selected-menu*/
    public void reset() {
        option.reset();
    }
    
    /**Return the selected turret*/
    public Turret getSelectedTurret() {
        return option.turret;
    }
    
    /**Return the next wave*/
    public Wave getWave() {
        if(wave[waveNum-1] == 'A') return new Wave("NORMAL", 20, strength, health, 1);
        if(wave[waveNum-1] == 'B') return new Wave("FAST", 10, strength, health, 2);
        if(wave[waveNum-1] == 'C') return new Wave("BIG", 5, strength, health, 4);
        if(wave[waveNum-1] == 'D') return new Wave("HARD", 10, strength, health, 2);
        return null;
    }
    
    public void nextWave() {
        nextWaveIn = 50;
        frame = 0;
        strength++;
        health+=waveNum*1.5;
        waveNum++;
        myBase.newWave(getWave());
        Time.setShowedValue(50);
        Greenfoot.playSound("hooray.wav");
    }
    
    public static boolean randomChance(int percent) {
        return Greenfoot.getRandomNumber(100) < percent;
    }
}